"""
Collection of utilities related to the Language Server Protocol (LSP).
"""

from typing import List, Optional, Text, Tuple

from asts import FunctionAST, RootAST
from pygls.lsp.types import (
    AnnotatedTextEdit,
    ChangeAnnotationIdentifier,
    ChangeAnnotation,
    Position,
    Range,
    TextDocumentEdit,
    WorkspaceEdit,
    VersionedTextDocumentIdentifier,
)
from pygls.workspace import Document

from function_generator.ast_utils import (
    ast_source_range,
    find_function,
    function_docstring,
    function_body_without_docstring,
)
from function_generator.text import get_indentation, indent


def range_to_tuple(r: Range) -> Tuple[Tuple[int, int], Tuple[int, int]]:
    """
    Convert the given LSP range to a tuple representation.
    """
    return ((r.start.line, r.start.character), (r.end.line, r.end.character))


def annotated_text_edit(
    text: Text,
    start_lineno: int,
    end_lineno: int,
    annotation_id: ChangeAnnotationIdentifier,
) -> AnnotatedTextEdit:
    """
    Create an LSP AnnotatedTextEdit object to insert TEXT into a document
    between START_LINENO and END_LINENO with the given ANNOTATION_ID.
    """
    start = Position(line=start_lineno, character=0)
    end = Position(line=end_lineno, character=0)
    r = Range(start=start, end=end)
    return AnnotatedTextEdit(
        newText=text,
        range=r,
        annotation_id=annotation_id,
    )


def workspace_edit(
    document: Document,
    text_edits: List[AnnotatedTextEdit],
) -> WorkspaceEdit:
    """
    Create an LSP WorkspaceEdit object to insert TEXT_EDITS into DOCUMENT.
    """
    text_document = VersionedTextDocumentIdentifier(
        uri=document.uri,
        version=document.version,
    )

    document_changes = [TextDocumentEdit(text_document=text_document, edits=text_edits)]

    change_annotations = {
        text_edit.annotation_id: ChangeAnnotation(
            label=text_edit.annotation_id,
            needs_confirmation=True,
        )
        for text_edit in text_edits
    }

    return WorkspaceEdit(
        document_changes=document_changes,
        change_annotations=change_annotations,
    )


def function_edit(
    document: Document,
    script: RootAST,
    function_name: str,
    completion: List[FunctionAST],
) -> Optional[WorkspaceEdit]:
    """
    Create an LSP WorkspaceEdit object on DOCUMENT to insert the
    COMPLETION generated by the model for the given FUNCTION_NAME
    in SCRIPT.
    """

    def should_create_edit(
        existing: FunctionAST,
        completion: List[FunctionAST],
    ) -> bool:
        """
        Return TRUE if an LSP TextEdit object should be created to
        replace EXISTING function with the given COMPLETION.
        """
        if len(completion) == 1:
            # There is only one function in the completion, test
            # if it is identical to the existing function.
            existing_body = existing.body.source_text.strip()
            completion_body = completion[0].body.source_text.strip()
            return existing_body != completion_body
        else:
            # We are replacing an existing function with multiple
            # functions.
            return True

    def build_edit_pairs(
        script: RootAST,
        completion: List[FunctionAST],
    ) -> List[Tuple[FunctionAST, List[FunctionAST]]]:
        """
        Return a list matching a functions in SCRIPT to their replacement
        AST(s) in the COMPLETION result.
        """
        pairs = {}
        existing_function = None
        qname_base = ".".join(function_name.split(".")[:-1])

        for new_function in completion:
            fname = new_function.function_name()
            qname = qname_base + "." + fname if qname_base else fname
            if find_function(script, qname):
                existing_function = find_function(script, qname)

            pairs.setdefault(existing_function, [])
            pairs[existing_function].append(new_function)

        pairs = list(pairs.items())
        pairs = [pair for pair in pairs if should_create_edit(*pair)]
        return pairs

    def same_docstring(function_a: FunctionAST, function_b: FunctionAST) -> bool:
        """
        Return TRUE if FUNCTION_A and FUNCTION_B have the same docstring.
        """
        a_docstring = function_docstring(function_a)
        b_docstring = function_docstring(function_b)
        a_text = a_docstring.source_text.strip() if a_docstring else None
        b_text = b_docstring.source_text.strip() if b_docstring else None
        return a_text == b_text

    def match_indentation(text: Text, function: FunctionAST) -> Text:
        """
        Indent TEXT to match the top-level indentation of FUNCTION.
        """
        lineno = ast_source_range(script, function.name)[0][0]
        indentation = get_indentation(document.source, lineno)
        return indent(text, indentation)

    def format_leading_trailing_newlines(
        text: Text,
        start_lineno: int,
        end_lineno: int,
    ) -> Text:
        """
        Format the start/end newlines in TEXT depending on the START_LINENO
        and END_LINENO in the document we are inserting TEXT into.
        """
        num_lines = len(document.source.splitlines())

        if start_lineno != num_lines:
            # No leading newline unless we are adding a line *below*
            # the current end of the document.
            text = text.lstrip("\n")
        if end_lineno != num_lines:
            # Add a trailing newline unless we are at the current
            # end of the document.
            text = text + "\n"

        return text

    def create_text_edit(
        function: FunctionAST,
        completion: List[FunctionAST],
    ) -> AnnotatedTextEdit:
        """
        Create an LSP AnnotatedTextEdit object to replace FUNCTION with the
        given COMPLETION.
        """

        children = function.body.child_slot("children")

        if same_docstring(function, completion[0]):
            # The existing function and first completion share the same
            # documentation string.

            # Create the source text of the replacement.
            for i, c in enumerate(completion):
                if i == 0:
                    text = function_body_without_docstring(completion[0]).source_text
                else:
                    text = text + "\n\n\n" + c.source_text

            # If the existing function contains only a documentation string,
            # append the completion text to the function (1).  Otherwise,
            # replace the existing function body after the documentation string.
            if not function_body_without_docstring(function):  # (1)
                start_lineno = ast_source_range(script, children[0])[1][0]
                end_lineno = start_lineno
            else:  # (2)
                start_lineno = ast_source_range(script, children[1])[0][0]
                end_lineno = ast_source_range(script, children[-1])[1][0]

        else:
            # Replace the entire function body, including the documentation string.
            text = "\n\n\n".join([c.source_text for c in completion])
            start_lineno = ast_source_range(script, children[0])[0][0]
            end_lineno = ast_source_range(script, children[-1])[1][0]

        # Format the text for insertion into the given location.
        text = match_indentation(text, function)
        text = format_leading_trailing_newlines(text, start_lineno, end_lineno)

        # Create and return the LSP object to perform the edit.
        return annotated_text_edit(
            text,
            start_lineno,
            end_lineno,
            function.function_name(),
        )

    text_edits = []
    for function, completion in build_edit_pairs(script, completion):
        text_edit = create_text_edit(function, completion)
        text_edits.append(text_edit)

    return workspace_edit(document, text_edits) if text_edits else None
